
/**
   Run a number of (completely) independent
   tasks in a thread pool.

   Try changing the number of worker threads in the thread pool.

   Try changing the number of tasks submitted to the thread pool.
*/
public class TasksInThreadPool_v1
{
   public static void main(String[] args)
   {
    //final int cores = Runtime.getRuntime().availableProcessors();
      final int cores = 3;

      final MyThreadPool_v1 executor = new MyThreadPool_v1(cores);

      final Task<Integer,Integer> task1 = new Task<>(1, 1, 1);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 2);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 3);
      final Task<Integer,Integer> task4 = new Task<>(3, 3, 4);
      final Task<Integer,Integer> task5 = new Task<>(3, 3, 5);
      final Task<Integer,Integer> task6 = new Task<>(3, 3, 6);

      executor.execute( task1 );
      executor.execute( task2 );
      executor.execute( task3 );
      executor.execute( task4 );
      executor.execute( task5 );
      executor.execute( task6 );

      executor.shutdown();
   }
}
